Bugzilla will be upgraded to version 5.0 on December 2, 2018. The outage period for the upgrade will start at 0:00 UTC and have a duration of 12 hours
Bug 623637 - [RHEL 4] Fix nfsd4 permissions problem
[RHEL 4] Fix nfsd4 permissions problem
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.8
All Linux
medium Severity medium
: rc
: ---
Assigned To: Red Hat Kernel Manager
Red Hat Kernel QE team
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-08-12 07:30 EDT by Sachin Prabhu
Modified: 2018-11-14 13:47 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-06-14 15:56:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
User provided patch (1.03 KB, patch)
2010-08-12 07:33 EDT, Sachin Prabhu
no flags Details | Diff

  None (edit)
Description Sachin Prabhu 2010-08-12 07:30:08 EDT
We have a customer request to backport the following patch

commit 7fc90ec93a5eb71f4b08403baf5ba7176b3ec6b1
Author: J. Bruce Fields <bfields@citi.umich.edu>
Date:   Fri Jun 30 01:56:14 2006 -0700

    [PATCH] knfsd: nfsd: call nfsd_setuser() on fh_compose(), fix nfsd4 permissions problem

This patch also needs to be followed by

commit d1bbf14f37261c2c0dba71404602e1ddcec069d2
Author: NeilBrown <neilb@suse.de>
Date:   Sun Jul 30 03:03:16 2006 -0700

    [PATCH] knfsd: Fix stale file handle problem with subtree_checking.

which fixes a bug in the original patch.

Copying the description from the earlier patch

--
From: J. Bruce Fields <bfields@citi.umich.edu>

In the typical v2/v3 case the only new filehandles used as arguments to
operations are filehandles taken directly off the wire, which don't get
dentries until fh_verify() is called.

But in v4 the filehandles that are arguments to operations were often
created by previous operations (putrootfh, lookup, etc.) using
fh_compose, which sets the dentry in the filehandle without calling
nfsd_setuser().

This also means that, for example, if filesystem B is mounted on filesystem
A, and filesystem A is exported without root-squashing, then a client can
bypass the rootsquashing on B using a compound that starts at a filehandle
in A, crosses into B using lookups, and then does stuff in B.
--
Comment 2 Sachin Prabhu 2010-08-12 07:33:46 EDT
Created attachment 438406 [details]
User provided patch

Patch which combines the changes in 
git commits
7fc90ec93a5eb71f4b08403baf5ba7176b3ec6b1
and
d1bbf14f37261c2c0dba71404602e1ddcec069d2

Note You need to log in before you can comment on or make changes to this bug.